(function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
var CannotConnectAlert, ExtVersion, LiveReloadGlobal, Status, TabState, TheWebSocket;

ExtVersion = require('./version');

Status = {
  unavailable: {
    buttonEnabled: false,
    buttonToolTip: 'LiveReload not available on this tab',
    buttonIcon: 'IconUnavailable.png',
    buttonIconHiRes: 'IconUnavailable@2x.png'
  },
  disabled: {
    buttonEnabled: true,
    buttonToolTip: 'Enable LiveReload',
    buttonIcon: 'IconDisabled.png',
    buttonIconHiRes: 'IconDisabled@2x.png'
  },
  enabled: {
    buttonEnabled: true,
    buttonToolTip: 'LiveReload is connecting, click to disable',
    buttonIcon: 'IconEnabled.png',
    buttonIconHiRes: 'IconEnabled@2x.png'
  },
  active: {
    buttonEnabled: true,
    buttonToolTip: 'LiveReload is connected, click to disable',
    buttonIcon: 'IconActive.png',
    buttonIconHiRes: 'IconActive@2x.png'
  }
};

TabState = (function() {
  function TabState(tab) {
    this.tab = tab;
    this.enabled = false;
    this.active = false;
  }

  TabState.prototype.enable = function() {
    return this.send('enable', {
      useFallback: this.useFallback,
      scriptURI: this.bundledScriptURI(),
      host: LiveReloadGlobal.host,
      port: LiveReloadGlobal.port
    });
  };

  TabState.prototype.disable = function() {
    return this.send('disable');
  };

  TabState.prototype.updateStatus = function(status) {
    if (status.initial) {
      if (!status.enabled) {
        this.active = false;
        if (this.enabled) {
          this.enable();
        }
        return;
      }
    }
    if (status.enabled != null) {
      this.enabled = status.enabled;
    }
    if (status.active != null) {
      return this.active = status.active;
    }
  };

  TabState.prototype.status = function() {
    switch (false) {
      case !this.active:
        return Status.active;
      case !this.enabled:
        return Status.enabled;
      default:
        return Status.disabled;
    }
  };

  TabState.prototype.alert = function(message) {
    return this.send('alert', message);
  };

  return TabState;

})();

if (navigator.userAgent.match(/Mac OS X/)) {
  CannotConnectAlert = "Could not connect to LiveReload server. Please make sure that LiveReload 2.3 (or later) or another compatible server is running.";
} else {
  CannotConnectAlert = "Could not connect to LiveReload server. Please make sure that a compatible LiveReload server is running. (We recommend guard-livereload, until LiveReload 2 comes to your platform.)";
}

TheWebSocket = typeof WebSocket !== "undefined" && WebSocket !== null ? WebSocket : MozWebSocket;

LiveReloadGlobal = {
  _tabs: [],
  initialize: function() {
    this.host = '127.0.0.1';
    return this.port = 35729;
  },
  killZombieTabs: function() {
    var tabState;
    return this._tabs = (function() {
      var _i, _len, _ref, _results;
      _ref = this._tabs;
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        tabState = _ref[_i];
        if (this.isAvailable(tabState.tab)) {
          _results.push(tabState);
        }
      }
      return _results;
    }).call(this);
  },
  killZombieTab: function(tab) {
    var index, tabState, _i, _len, _ref;
    _ref = this._tabs;
    for (index = _i = 0, _len = _ref.length; _i < _len; index = ++_i) {
      tabState = _ref[index];
      if (tabState.tab === tab) {
        this._tabs.splice(index, 1);
        return;
      }
    }
  },
  findState: function(tab, create) {
    var state, tabState, _i, _len, _ref;
    if (create == null) {
      create = false;
    }
    _ref = this._tabs;
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      tabState = _ref[_i];
      if (tabState.tab === tab) {
        return tabState;
      }
    }
    if (create) {
      state = new TabState(tab);
      this._tabs.push(state);
      return state;
    } else {
      return null;
    }
  },
  toggle: function(tab) {
    var state;
    if (this.isAvailable(tab)) {
      state = this.findState(tab, true);
      if (state.enabled) {
        state.disable();
        if (!this.areAnyTabsEnabled()) {
          return this.afterDisablingLast();
        }
      } else {
        if (this.areAnyTabsEnabled()) {
          state.useFallback = this.useFallback;
          return state.enable();
        } else {
          return this.beforeEnablingFirst((function(_this) {
            return function(err) {
              if (err) {
                switch (err) {
                  case 'cannot-connect':
                    return state.alert(CannotConnectAlert);
                  case 'cannot-download':
                    return state.alert("Cannot download livereload.js");
                }
              } else {
                state.useFallback = _this.useFallback;
                return state.enable();
              }
            };
          })(this));
        }
      }
    }
  },
  tabStatus: function(tab) {
    var _ref;
    if (!this.isAvailable(tab)) {
      return Status.unavailable;
    }
    return ((_ref = this.findState(tab)) != null ? _ref.status() : void 0) || Status.disabled;
  },
  updateStatus: function(tab, status) {
    return this.findState(tab, true).updateStatus(status);
  },
  areAnyTabsEnabled: function() {
    var tabState, _i, _len, _ref;
    _ref = this._tabs;
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      tabState = _ref[_i];
      if (tabState.enabled) {
        return true;
      }
    }
    return false;
  },
  beforeEnablingFirst: function(callback) {
    var callbackCalled, failOnTimeout, timeout, ws;
    this.useFallback = false;
    callbackCalled = false;
    failOnTimeout = function() {
      console.log("Haven't received a handshake reply in time, disconnecting.");
      return ws.close();
    };
    timeout = setTimeout(failOnTimeout, 1000);
    console.log("Connecting to ws://" + this.host + ":" + this.port + "/livereload...");
    ws = new TheWebSocket("ws://" + this.host + ":" + this.port + "/livereload");
    ws.onerror = (function(_this) {
      return function() {
        console.log("Web socket error.");
        if (!callbackCalled) {
          callback('cannot-connect');
        }
        return callbackCalled = true;
      };
    })(this);
    ws.onopen = (function(_this) {
      return function() {
        console.log("Web socket connected, sending handshake.");
        return ws.send(JSON.stringify({
          command: 'hello',
          protocols: ['http://livereload.com/protocols/connection-check-1']
        }));
      };
    })(this);
    ws.onclose = function() {
      console.log("Web socket disconnected.");
      if (!callbackCalled) {
        callback('cannot-connect');
      }
      return callbackCalled = true;
    };
    return ws.onmessage = (function(_this) {
      return function(event) {
        var xhr;
        if (timeout) {
          clearTimeout(timeout);
        }
        timeout = null;
        console.log("Incoming message: " + event.data);
        if (event.data.match(/^!!/)) {
          _this.useFallback = true;
          if (!callbackCalled) {
            callback(null);
          }
          callbackCalled = true;
          return ws.close();
        } else if (event.data.match(/^\{/)) {
          xhr = new XMLHttpRequest();
          xhr.onreadystatechange = function() {
            if (xhr.readyState === XMLHttpRequest.DONE && xhr.status === 200) {
              _this.script = xhr.responseText;
              if (!callbackCalled) {
                callback(null);
              }
              return callbackCalled = true;
            }
          };
          xhr.onerror = function(event) {
            if (!callbackCalled) {
              callback('cannot-download');
            }
            return callbackCalled = true;
          };
          xhr.open("GET", "http://" + _this.host + ":" + _this.port + "/livereload.js", true);
          return xhr.send(null);
        }
      };
    })(this);
  },
  afterDisablingLast: function() {},
  received: function(eventName, data) {
    var func;
    if (func = this["on " + eventName]) {
      return func.call(this, data);
    }
  },
  'on resourceAdded': function(_arg) {
    var url;
    url = _arg.url;
    return console.log("Resource added: " + url);
  },
  'on resourceUpdated': function(_arg) {
    var content, url;
    url = _arg.url, content = _arg.content;
    return console.log("Resource updated: " + url);
  }
};

exports.TabState = TabState;

exports.LiveReloadGlobal = LiveReloadGlobal;



},{"./version":3}],2:[function(require,module,exports){
var CustomEvents, ExtVersion, LiveReloadInjected;

CustomEvents = {
  bind: function(element, eventName, handler) {
    if (element.addEventListener) {
      return element.addEventListener(eventName, handler, false);
    } else if (element.attachEvent) {
      element[eventName] = 1;
      return element.attachEvent('onpropertychange', function(event) {
        if (event.propertyName === eventName) {
          return handler();
        }
      });
    } else {
      throw new Error("Attempt to attach custom event " + eventName + " to something which isn't a DOMElement");
    }
  },
  fire: function(element, eventName) {
    var document, event;
    document = element instanceof HTMLDocument ? element : element.ownerDocument;
    if (element.addEventListener) {
      event = document.createEvent('HTMLEvents');
      event.initEvent(eventName, true, true);
      return document.dispatchEvent(event);
    } else if (element.attachEvent) {
      if (element[eventName]) {
        return element[eventName]++;
      }
    } else {
      throw new Error("Attempt to fire custom event " + eventName + " on something which isn't a DOMElement");
    }
  }
};

ExtVersion = require('./version');

LiveReloadInjected = (function() {
  function LiveReloadInjected(document, window, extName) {
    var _ref, _ref1, _ref2;
    this.document = document;
    this.window = window;
    this.extName = extName;
    this._hooked = false;
    this._verbose = !!((_ref = this.window) != null ? (_ref1 = _ref.location) != null ? (_ref2 = _ref1.href) != null ? _ref2.match(/LR-verbose/) : void 0 : void 0 : void 0);
    setTimeout(((function(_this) {
      return function() {
        return _this.determineInitialState();
      };
    })(this)), 1);
  }

  LiveReloadInjected.prototype.determineInitialState = function() {
    if (this.findScriptTag()) {
      this.send('status', {
        enabled: true,
        active: true,
        initial: true
      });
      return this.hook();
    } else {
      return this.send('status', {
        enabled: false,
        active: false,
        initial: true
      });
    }
  };

  LiveReloadInjected.prototype.findScriptTag = function() {
    var element, m, src, _i, _len, _ref;
    _ref = this.document.getElementsByTagName('script');
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      element = _ref[_i];
      if (src = element.src) {
        if (m = src.match(/\/livereload\.js(?:\?(.*))?$/)) {
          return element;
        }
      }
    }
    return null;
  };

  LiveReloadInjected.prototype.doDisable = function(callback) {
    var element;
    element = this.findScriptTag();
    if (element) {
      CustomEvents.fire(this.document, 'LiveReloadShutDown');
      if (element.parentNode) {
        element.parentNode.removeChild(element);
      }
    }
    return callback();
  };

  LiveReloadInjected.prototype.doEnable = function(_arg) {
    var element, scriptURI, url, useFallback, _ref;
    useFallback = _arg.useFallback, scriptURI = _arg.scriptURI, this.host = _arg.host, this.port = _arg.port;
    if (((_ref = this.document.documentElement) != null ? _ref.contentEditable : void 0) === 'true') {
      return;
    }
    if (useFallback) {
      url = "" + scriptURI + "?ext=" + this.extName + "&extver=" + ExtVersion + "&host=" + this.host + "&port=" + this.port;
      if (this._verbose) {
        console.log("Loading LiveReload.js bundled with the browser extension...");
      }
    } else {
      url = "http://" + this.host + ":" + this.port + "/livereload.js?ext=" + this.extName + "&extver=" + ExtVersion;
      if (this._verbose) {
        console.log("Loading LiveReload.js from " + (url.replace(/\?.*$/, '')) + "...");
      }
    }
    this.hook();
    element = this.document.createElement('script');
    element.src = url;
    return this.document.body.appendChild(element);
  };

  LiveReloadInjected.prototype.hook = function() {
    if (this._hooked) {
      return;
    }
    this._hooked = true;
    CustomEvents.bind(this.document, 'LiveReloadConnect', (function(_this) {
      return function() {
        return _this.send('status', {
          active: true
        });
      };
    })(this));
    return CustomEvents.bind(this.document, 'LiveReloadDisconnect', (function(_this) {
      return function() {
        return _this.send('status', {
          active: false
        });
      };
    })(this));
  };

  LiveReloadInjected.prototype.disable = function() {
    return this.doDisable((function(_this) {
      return function() {
        return _this.send('status', {
          enabled: false,
          active: false
        });
      };
    })(this));
  };

  LiveReloadInjected.prototype.enable = function(options) {
    return this.doDisable((function(_this) {
      return function() {
        _this.doEnable(options);
        return _this.send('status', {
          enabled: true
        });
      };
    })(this));
  };

  return LiveReloadInjected;

})();

exports.LiveReloadInjected = LiveReloadInjected;



},{"./version":3}],3:[function(require,module,exports){
var ExtVersion;

module.exports = ExtVersion = '2.1.0';



},{}],4:[function(require,module,exports){
var LiveReloadGlobal, LiveReloadInjected, TabState, ToggleButton, findTabByContentDocument, _ref;

_ref = require('../common/global'), LiveReloadGlobal = _ref.LiveReloadGlobal, TabState = _ref.TabState;

LiveReloadInjected = require('../common/injected').LiveReloadInjected;

findTabByContentDocument = function(doc) {
  var tab, _i, _len, _ref1;
  _ref1 = gBrowser.tabs;
  for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
    tab = _ref1[_i];
    if (gBrowser.getBrowserForTab(tab).contentDocument === doc) {
      return tab;
    }
  }
  return null;
};

LiveReloadInjected.prototype.send = function(eventName, data) {
  var tab;
  tab = findTabByContentDocument(this.document);
  if (!tab) {
    return;
  }
  switch (eventName) {
    case 'status':
      LiveReloadGlobal.updateStatus(tab, data);
      return ToggleButton.update();
  }
};

TabState.prototype.send = function(eventName, data) {
  var doc, injected;
  if (data == null) {
    data = {};
  }
  doc = gBrowser.getBrowserForTab(this.tab).contentDocument;
  injected = doc.__LiveReload_injected;
  if (!injected) {
    alert("There is no LiveReloadInjected for " + doc.location.href);
    return;
  }
  switch (eventName) {
    case 'alert':
      return alert(data);
    case 'enable':
      return injected.enable(data);
    case 'disable':
      return injected.disable();
  }
};

TabState.prototype.bundledScriptURI = function() {
  return 'chrome://livereload/content/livereload.js';
};

LiveReloadGlobal.isAvailable = function(tab) {
  return true;
};

LiveReloadGlobal.initialize();

ToggleButton = {
  initialize: function() {
    this.toggleButton = document.getElementById('livereload-button');
    return this.toggleButton.addEventListener('command', function(event) {
      LiveReloadGlobal.toggle(gBrowser.selectedTab);
      return ToggleButton.update();
    });
  },
  update: function() {
    var status;
    status = LiveReloadGlobal.tabStatus(gBrowser.selectedTab);
    this.toggleButton.tooltiptext = status.buttonToolTip;
    return this.toggleButton.image = "chrome://livereload/skin/" + status.buttonIcon;
  }
};

window.addEventListener('load', function() {
  var ContentScriptInjectionSimulation;
  ToggleButton.initialize();
  ContentScriptInjectionSimulation = {
    initialize: function() {
      return gBrowser.addEventListener('DOMContentLoaded', function(event) {
        var doc, win, _ref1;
        doc = event.originalTarget;
        win = doc.defaultView;
        if ((doc != null ? (_ref1 = doc.location) != null ? _ref1.href : void 0 : void 0) === 'about:blank') {
          return;
        }
        doc.__LiveReload_injected = new LiveReloadInjected(doc, win, 'Firefox');
        return win.addEventListener("unload", function(event) {
          return doc.__LiveReload_injected = null;
        });
      });
    }
  };
  ContentScriptInjectionSimulation.initialize();
  gBrowser.tabContainer.addEventListener('TabSelect', function(event) {
    var tab;
    tab = event.target;
    return ToggleButton.update();
  });
  return gBrowser.tabContainer.addEventListener('TabClose', function(event) {
    LiveReloadGlobal.killZombieTab(event.target);
    return ToggleButton.update();
  });
});



},{"../common/global":1,"../common/injected":2}]},{},[4]);
